import { SubType } from '../internalTypes';
interface NamespacedConfiguration {
    [namespace: string]: {
        state?: {};
        effects?: {};
        actions?: {};
        reactions?: {};
    };
}
export declare function namespaced<T extends NamespacedConfiguration>(namespaces: T): {
    state: SubType<{
        [P in keyof T]: T[P]['state'];
    }, object>;
    effects: SubType<{
        [P in keyof T]: T[P]['effects'];
    }, object>;
    actions: SubType<{
        [P in keyof T]: T[P]['actions'];
    }, object>;
};
export {};
